function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}
/*
 * File: iframeResizer.js
 * Desc: Force iframes to size to content.
 * Requires: iframeResizer.contentWindow.js to be loaded into the target frame.
 * Doc: https://github.com/davidjbradshaw/iframe-resizer
 * Author: David J. Bradshaw - dave@bradshaw.net
 * Contributor: Jure Mav - jure.mav@gmail.com
 * Contributor: Reed Dadoune - reed@dadoune.com
 */
// eslint-disable-next-line sonarjs/cognitive-complexity, no-shadow-restricted-names
!function(f){var l,m,a,v,I,
// Must match iframe msg ID
x,F,r,g,M,t,h,k,e;// don't run for server side render
function p(){return window.MutationObserver||window.WebKitMutationObserver||window.MozMutationObserver}function z(e,n,t){e.addEventListener(n,t,!1)}function O(e,n,t){e.removeEventListener(n,t,!1)}function o(e){return I+"["+(e="Host page: "+(n=e),window.top!==window.self&&(e=window.parentIFrame&&window.parentIFrame.getId?window.parentIFrame.getId()+": "+n:"Nested host page: "+n),e)+"]";var n}function i(e){return M[e]?M[e].log:m}function R(e,n){s("log",e,n,i(e))}function T(e,n){s("info",e,n,i(e))}function E(e,n){s("warn",e,n,!0)}function s(e,n,t,i){!0===i&&"object"===_typeof(window.console)&&
// eslint-disable-next-line no-console
console[e](o(n),t)}function n(n){function i(){e("Height"),e("Width"),A(function(){P(b),N(y),f("onResized",b)},b,"init")}function e(e){var n=Number(M[y]["max"+e]),t=Number(M[y]["min"+e]),i=e.toLowerCase(),e=Number(b[i]);R(y,"Checking "+i+" is in range "+t+"-"+n),e<t&&(e=t,R(y,"Set "+i+" to min value")),n<e&&(e=n,R(y,"Set "+i+" to max value")),b[i]=""+e}function a(e){return w.substr(w.indexOf(":")+v+e)}function s(t,i){var e,n,o;// Not testable in PhantomJS
/* istanbul ignore next */e=function(){var e,n;B("Send Page Info","pageInfo:"+(e=document.body.getBoundingClientRect(),n=b.iframe.getBoundingClientRect(),JSON.stringify({iframeHeight:n.height,iframeWidth:n.width,clientHeight:Math.max(document.documentElement.clientHeight,window.innerHeight||0),clientWidth:Math.max(document.documentElement.clientWidth,window.innerWidth||0),offsetTop:parseInt(n.top-e.top,10),offsetLeft:parseInt(n.left-e.left,10),scrollTop:window.pageYOffset,scrollLeft:window.pageXOffset,documentHeight:document.documentElement.clientHeight,documentWidth:document.documentElement.clientWidth,windowHeight:window.innerHeight,windowWidth:window.innerWidth})),t,i)},n=32,k[o=i]||(k[o]=setTimeout(function(){k[o]=null,e()},n))}function d(e){e=e.getBoundingClientRect();return C(y),{x:Math.floor(Number(e.left)+Number(F.x)),y:Math.floor(Number(e.top)+Number(F.y))}}function c(e){var n=e?d(b.iframe):{x:0,y:0},t={x:Number(b.width)+n.x,y:Number(b.height)+n.y};R(y,"Reposition requested from iFrame (offset x:"+n.x+" y:"+n.y+")"),window.top!==window.self?window.parentIFrame?window.parentIFrame["scrollTo"+(e?"Offset":"")](t.x,t.y):E(y,"Unable to scroll to requested position, window.parentIFrame not found"):(F=t,u(),R(y,"--"))}function u(){!1!==f("onScroll",F)?N(y):H()}function f(e,n){return S(y,e,n)}var t,o,r,l,m,g,h,p,w=n.data,b={},y=null;"[iFrameResizerChild]Ready"===w?function(){
// eslint-disable-next-line no-restricted-syntax, guard-for-in
for(var e in M)B("iFrame requested init",L(e),M[e].iframe,e)}():I===(""+w).substr(0,x)&&w.substr(x).split(":")[0]in M?(m=w.substr(x).split(":"),g=m[1]?parseInt(m[1],10):0,h=M[m[0]]&&M[m[0]].iframe,p=getComputedStyle(h),b={iframe:h,id:m[0],height:g+function(e){if("border-box"!==e.boxSizing)return 0;var n=e.paddingTop?parseInt(e.paddingTop,10):0,e=e.paddingBottom?parseInt(e.paddingBottom,10):0;return n+e}(p)+function(e){if("border-box"!==e.boxSizing)return 0;var n=e.borderTopWidth?parseInt(e.borderTopWidth,10):0,e=e.borderBottomWidth?parseInt(e.borderBottomWidth,10):0;return n+e}(p),width:m[2],type:m[3]},y=b.id,M[y]&&(M[y].loaded=!0),(l=b.type in{true:1,false:1,undefined:1})&&R(y,"Ignoring init message from meta parent page"),!l&&(r=!0,M[o=y]||(r=!1,E(b.type+" No settings for "+o+". Message was: "+w)),r)&&(R(y,"Received: "+w),t=!0,null===b.iframe&&(E(y,"IFrame ("+b.id+") not found"),t=!1),t&&function(){var e,t=n.origin,i=M[y]&&M[y].checkOrigin;if(i&&""+t!="null"&&!(i.constructor===Array?function(){var e=0,n=!1;for(R(y,"Checking connection is from allowed list of origins: "+i);e<i.length;e++)if(i[e]===t){n=!0;break}return n}():(e=M[y]&&M[y].remoteHost,R(y,"Checking connection is from: "+e),t===e)))throw new Error("Unexpected message received from: "+t+" for "+b.iframe.id+". Message was: "+n.data+". This error can be disabled by setting the checkOrigin: false option or by providing of array of trusted domains.");return 1}()&&function(){switch(M[y]&&M[y].firstRun&&M[y]&&(M[y].firstRun=!1),b.type){case"close":W(b.iframe);break;case"message":n=a(6),R(y,"onMessage passed: {iframe: "+b.iframe.id+", message: "+n+"}"),f("onMessage",{iframe:b.iframe,message:JSON.parse(n)}),R(y,"--");break;case"autoResize":M[y].autoResize=JSON.parse(a(9));break;case"scrollTo":c(!1);break;case"scrollToOffset":c(!0);break;case"pageInfo":s(M[y]&&M[y].iframe,y),o=y,t("Add ",z),M[o]&&(M[o].stopPageInfo=r);break;case"pageInfoStop":M[y]&&M[y].stopPageInfo&&(M[y].stopPageInfo(),delete M[y].stopPageInfo);break;case"inPageLink":e=a(9),n=e.split("#")[1]||"",e=decodeURIComponent(n),(e=document.getElementById(e)||document.getElementsByName(e)[0])?(e=d(e),R(y,"Moving to in page link (#"+n+") at x: "+e.x+" y: "+e.y),F={x:e.x,y:e.y},u(),R(y,"--")):window.top!==window.self?window.parentIFrame?window.parentIFrame.moveToAnchor(n):R(y,"In page link #"+n+" not found and window.parentIFrame not found"):R(y,"In page link #"+n+" not found");break;case"reset":j(b);break;case"init":i(),f("onInit",b.iframe);break;default:i()}var e,o,n;function t(n,t){function i(){M[o]?s(M[o].iframe,o):r()}["scroll","resize"].forEach(function(e){R(o,n+e+" listener for sendPageInfo"),t(window,e,i)})}function r(){t("Remove ",O)}}())):T(y,"Ignored: "+w)}function S(e,n,t){var i=null,o=null;if(M[e]){if("function"!=typeof(i=M[e][n]))throw new TypeError(n+" on iFrame["+e+"] is not a function");o=i(t)}return o}function w(e){e=e.id;delete M[e]}function W(e){var n=e.id;if(!1!==S(n,"onClose",n)){R(n,"Removing iFrame: "+n);try{
// Catch race condition error with React
e.parentNode&&e.parentNode.removeChild(e)}catch(e){E(e)}S(n,"onClosed",n),R(n,"--"),w(e)}else R(n,"Close iframe cancelled by onClose event")}function C(e){null===F&&R(e,"Get page position: "+(F={x:window.pageXOffset!==f?window.pageXOffset:document.documentElement.scrollLeft,y:window.pageYOffset!==f?window.pageYOffset:document.documentElement.scrollTop}).x+","+F.y)}function N(e){null!==F&&(window.scrollTo(F.x,F.y),R(e,"Set page position: "+F.x+","+F.y),H())}function H(){F=null}function j(e){R(e.id,"Size reset requested by "+("init"===e.type?"host page":"iFrame")),C(e.id),A(function(){P(e),B("reset","reset",e.iframe,e.id)},e,"reset")}function P(o){function t(e){function n(){Object.keys(M).forEach(function(e){function n(e){return"0px"===(M[t]&&M[t].iframe.style[e])}var t;M[t=e]&&null!==M[t].iframe.offsetParent&&(n("height")||n("width"))&&B("Visibility change","resize",M[t].iframe,t)})}function t(e){R("window","Mutation observed: "+e[0].target+" "+e[0].type),c(n,16)}var i;
// FireFox sets dimension of hidden iFrames to zero.
// So if we detect that set up an event to check for
// when iFrame becomes visible.
/* istanbul ignore next */
// Not testable in PhantomJS
a||"0"!==o[e]||(a=!0,R(r,"Hidden iFrame detected, creating visibility listener"),(i=p())&&function(){var e=document.querySelector("body");new i(t).observe(e,{attributes:!0,attributeOldValue:!1,characterData:!0,characterDataOldValue:!1,childList:!0,subtree:!0})}())}function e(e){var n;n=e,o.id?(o.iframe.style[n]=o[n]+"px",R(o.id,"IFrame ("+r+") "+n+" set to "+o[n]+"px")):R("undefined","messageData id not set"),t(e)}var r=o.iframe.id;M[r]&&(M[r].sizeHeight&&e("height"),M[r].sizeWidth&&e("width"))}function A(e,n,t){
/* istanbul ignore if */
// Not testable in PhantomJS
t!==n.type&&r&&// including check for jasmine because had trouble getting spy to work in unit test using requestAnimationFrame
!window.jasmine?(R(n.id,"Requesting animation frame"),r(e)):e()}function B(e,n,t,i,o){var r,a=!1;i=i||t.id,M[i]&&(t&&"contentWindow"in t&&null!==t.contentWindow?(
// Null test for PhantomJS
r=M[i]&&M[i].targetOrigin,R(i,"["+e+"] Sending msg to iframe["+i+"] ("+n+") targetOrigin: "+r),t.contentWindow.postMessage(I+n,r)):E(i,"["+e+"] IFrame("+i+") not found"),o&&M[i]&&M[i].warningTimeout&&(M[i].msgTimeout=setTimeout(function(){!M[i]||M[i].loaded||a||(a=!0,E(i,"IFrame has not responded within "+M[i].warningTimeout/1e3+" seconds. Check iFrameResizer.contentWindow.js has been loaded in iFrame. This message can be ignored if everything is working, or you can set the warningTimeout option to a higher value or zero to suppress this warning."))},M[i].warningTimeout)))}function L(e){return e+":"+M[e].bodyMarginV1+":"+M[e].sizeWidth+":"+M[e].log+":"+M[e].interval+":"+M[e].enablePublicMethods+":"+M[e].autoResize+":"+M[e].bodyMargin+":"+M[e].heightCalculationMethod+":"+M[e].bodyBackground+":"+M[e].bodyPadding+":"+M[e].tolerance+":"+M[e].inPageLinks+":"+M[e].resizeFrom+":"+M[e].widthCalculationMethod}function d(t,e){function n(e){var n=e.split("Callback");2===n.length&&(this[n="on"+n[0].charAt(0).toUpperCase()+n[0].slice(1)]=this[e],delete this[e],E(d,"Deprecated: '"+e+"' has been renamed '"+n+"'. The old method will be removed in the next major version."))}var i,o,r,a,s,d=(""===(i=t.id)&&(
// eslint-disable-next-line no-multi-assign
t.id=(o=e&&e.id||h.id+l++,null!==document.getElementById(o)&&(o+=l++),i=o),m=(e||{}).log,R(i,"Added missing iframe ID: "+i+" ("+t.src+")")),i);function c(e){1/0!==M[d][e]&&0!==M[d][e]&&(t.style[e]=M[d][e]+"px",R(d,"Set "+e+" = "+M[d][e]+"px"))}function u(e){if(M[d]["min"+e]>M[d]["max"+e])throw new Error("Value for min"+e+" can not be greater than max"+e)}d in M&&"iFrameResizer"in t?E(d,"Ignored iFrame, already setup."):(s=(s=e)||{},M[d]={firstRun:!0,iframe:t,remoteHost:t.src&&t.src.split("/").slice(0,3).join("/")},function(e){if("object"!==_typeof(e))throw new TypeError("Options is not an object")}(s),Object.keys(s).forEach(n,s),function(e){
// eslint-disable-next-line no-restricted-syntax
for(var n in h)Object.prototype.hasOwnProperty.call(h,n)&&(M[d][n]=(Object.prototype.hasOwnProperty.call(e,n)?e:h)[n])}(s),M[d]&&(M[d].targetOrigin=!0===M[d].checkOrigin?""===(s=M[d].remoteHost)||null!==s.match(/^(about:blank|javascript:|file:\/\/)/)?"*":s:"*"),function(){switch(R(d,"IFrame scrolling "+(M[d]&&M[d].scrolling?"enabled":"disabled")+" for "+d),t.style.overflow=!1===(M[d]&&M[d].scrolling)?"hidden":"auto",M[d]&&M[d].scrolling){case"omit":break;case!0:t.scrolling="yes";break;case!1:t.scrolling="no";break;default:t.scrolling=M[d]?M[d].scrolling:"no"}}// The V1 iFrame script expects an int, where as in V2 expects a CSS
// string value such as '1px 3em', so if we have an int for V2, set V1=V2
// and then convert V2 to a string PX value.
(),u("Height"),u("Width"),c("maxHeight"),c("minHeight"),c("maxWidth"),c("minWidth"),"number"!=typeof(M[d]&&M[d].bodyMargin)&&"0"!==(M[d]&&M[d].bodyMargin)||(M[d].bodyMarginV1=M[d].bodyMargin,M[d].bodyMargin=M[d].bodyMargin+"px"),r=L(d),(a=p())&&(a=a,t.parentNode&&new a(function(e){e.forEach(function(e){// Transform NodeList into an Array
Array.prototype.slice.call(e.removedNodes).forEach(function(e){e===t&&W(t)})})}).observe(t.parentNode,{childList:!0})),z(t,"load",function(){var e,n;B("iFrame.onload",r,t,f,!0),e=M[d]&&M[d].firstRun,n=M[d]&&M[d].heightCalculationMethod in g,!e&&n&&j({iframe:t,height:0,width:0,type:"init"})}),B("init",r,t,f,!0),M[d]&&(M[d].iframe.iFrameResizer={close:W.bind(null,M[d].iframe),removeListeners:w.bind(null,M[d].iframe),resize:B.bind(null,"Window resize","resize",M[d].iframe),moveToAnchor:function(e){B("Move to anchor","moveToAnchor:"+e,M[d].iframe,d)},sendMessage:function(e){B("Send Message","message:"+(e=JSON.stringify(e)),M[d].iframe,d)}}))}function c(e,n){null===t&&(t=setTimeout(function(){t=null,e()},n))}// Not testable in PhantomJS
/* istanbul ignore next */
function u(){"hidden"!==document.visibilityState&&(R("document","Trigger event: Visiblity change"),c(function(){b("Tab Visable","resize")},16))}function b(t,i){Object.keys(M).forEach(function(e){var n;M[n=e]&&"parent"===M[n].resizeFrom&&M[n].autoResize&&!M[n].firstRun&&B(t,i,M[e].iframe,e)})}function y(){z(window,"message",n),z(window,"resize",function(){var e;R("window","Trigger event: "+(e="resize")),c(function(){b("Window "+e,"resize")},16)}),z(document,"visibilitychange",u),z(document,"-webkit-visibilitychange",u)}function q(){function i(e,n){n&&(function(){if(!n.tagName)throw new TypeError("Object is not a valid DOM element");if("IFRAME"!==n.tagName.toUpperCase())throw new TypeError("Expected <IFRAME> tag, found <"+n.tagName+">")}(),d(n,e),o.push(n))}var o;return function(){// Remove vendor prefixing if prefixed and break early if not
for(var e=["moz","webkit","o","ms"],n=0;n<e.length&&!r;n+=1)r=window[e[n]+"RequestAnimationFrame"];r?
// Firefox extension content-scripts have a globalThis object that is not the same as window.
// Binding `requestAnimationFrame` to window allows the function to work and prevents errors
// being thrown when run in that context, and should be a no-op in every other context.
r=r.bind(window):R("setup","RequestAnimationFrame not supported")}(),y(),function(e,n){var t;switch(o=[],(// Only return iFrames past in on this call
t=e)&&t.enablePublicMethods&&E("enablePublicMethods option has been removed, public methods are now always available in the iFrame"),_typeof(n)){case"undefined":case"string":Array.prototype.forEach.call(document.querySelectorAll(n||"iframe"),i.bind(f,e));break;case"object":i(e,n);break;default:throw new TypeError("Unexpected data type ("+_typeof(n)+")")}return o}}"undefined"!=typeof window&&(v="message".length,x=(I="[iFrameSizer]").length,r=window.requestAnimationFrame,h={autoResize:!(t=F=null),bodyBackground:null,bodyMargin:null,bodyMarginV1:8,bodyPadding:null,checkOrigin:!(a=m=!1),inPageLinks:!(M={}),enablePublicMethods:!(l=0),heightCalculationMethod:"bodyOffset",id:"iFrameResizer",interval:32,log:!(g={max:1,scroll:1,bodyScroll:1,documentElementScroll:1}),maxHeight:1/0,maxWidth:1/0,minHeight:0,minWidth:0,resizeFrom:"parent",scrolling:!1,sizeHeight:!0,sizeWidth:!1,warningTimeout:5e3,tolerance:0,widthCalculationMethod:"scroll",onClose:function(){return!0},onClosed:function(){},onInit:function(){},onMessage:function(){E("onMessage function not defined")},onResized:function(){},onScroll:function(){return!0}},k={},window.jQuery&&((e=window.jQuery).fn?e.fn.iFrameResize||(e.fn.iFrameResize=function(t){return this.filter("iframe").each(function(e,n){d(n,t)}).end()}):T("","Unable to bind to jQuery, it is not fully loaded.")),"function"==typeof define&&define.amd?define([],q):"object"===("undefined"==typeof module?"undefined":_typeof(module))&&"object"===_typeof(module.exports)&&(
// Node for browserfy
module.exports=q()),window.iFrameResize=window.iFrameResize||q())}();